<?php

/**
 * mod_vmrotmulti_randomprod
 *
 * @version 1.1
 * @author Creative Pulse
 * @copyright Creative Pulse 2008- Soeren Eberhardt 2004-2005 - Mr PHP 2000-2004
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @link http://www.creativepulse.eu
 */

defined('_JEXEC') or die('Restricted access');

class ModVmrotmultiRandomprod {

	var $items = array();
	var $width = 0;
	var $height = 0;
	var $interval = 0;
	var $speed = 0;
	var $show_addtocart = true;
	var $visible_items = 4;
	var $autoscroll_interval = 4;

	function instance_id($new = false) {
		static $num = 0;

		if ($new)
			$num++;
		else
			return $num;
	}

	function prepare(&$params) {
		$this->instance_id(true);

		global $mosConfig_absolute_path;
		
		// Load the virtuemart main parse code
		if( file_exists(dirname(__FILE__).'/../../components/com_virtuemart/virtuemart_parser.php' )) {
			require_once( dirname(__FILE__).'/../../components/com_virtuemart/virtuemart_parser.php' );
		} else {
			require_once( dirname(__FILE__).'/../components/com_virtuemart/virtuemart_parser.php' );
		}
		
		$this->width = (int) $params->get('width', 0);
		$this->height = (int) $params->get('height', 0);
		$this->interval = (int) $params->get('interval', 0);
		$this->speed = (int) $params->get('speed', 0);
		$max_items = (int) $params->get('max_items', 5); //maximum number of items to display
		$category_id = (string) $params->get('category_id', ''); // Display products from this category only
		$show_price = (bool) $params->get('show_price', 1 ); // Display the Product Price?
		$this->show_addtocart = (bool) $params->get('show_addtocart', 1); // Display the "Add-to-Cart" Link?
		$cur_vendor = $params->get('vendor', 'cur') == 'cur';
		$this->visible_items = (int) $params->get('visible_items', 4);
		$this->autoscroll_interval = ((float) $params->get('autoscroll_interval', 3)) * 1000;

		require_once(CLASSPATH . 'ps_product.php');
		$ps_product = new ps_product;
		$db = new ps_DB;

		preg_match_all('/[0-9]+/', $category_id, $cat_ids);
		$q = "SELECT DISTINCT p.product_sku FROM #__{vm}_product p" . (empty($cat_ids[0]) ? "" : ", #__{vm}_product_category_xref l")
			. " WHERE p.product_parent_id = 0"
			. " AND p.product_publish = 'Y'"
			. ($cur_vendor ? " AND p.vendor_id = '{$_SESSION['ps_vendor_id']}'" : "")
			. (CHECK_STOCK && PSHOP_SHOW_OUT_OF_STOCK_PRODUCTS != "1" ? " AND p.product_in_stock > 0 " : "")
			. (empty($cat_ids[0]) ? "" : " AND p.product_id = l.product_id AND l.category_id IN (" . implode(",", $cat_ids[0]) . ")")
			. " ORDER BY RAND()"
			. " LIMIT 0, $max_items";
		$db->query($q);
		
		if ($db->num_rows() > 0) {
			global $sess, $mm_action_url;
		
			require_once(CLASSPATH.'ps_product_category.php');
			$ps_product_category = new ps_product_category;
		
			// initialize data arrays
			$this->items = array();
			$skus = array();
			while ($db->next_record()) {
				$this->items[$db->f("product_sku")] = false;
				$skus[] = $db->getEscaped($db->f("product_sku"));
			}
		
			// fetch product information
			$q = "SELECT product_sku, product_id, product_name, product_parent_id, product_thumb_image FROM #__{vm}_product WHERE product_sku IN ('" . implode("','", $skus) . "')";
			$db->query($q);
		
			while ($db->next_record()) {
				$product_id = $db->f("product_id");
				$cid = $ps_product_category->get_cid($product_id);
			
				if ($db->f("product_parent_id")) {
					$url = "?page=shop.product_details&category_id=$cid&flypage=".$ps_product->get_flypage($db->f("product_parent_id"));
					$url .= "&product_id=" . $db->f("product_parent_id");
				} else {
					$url = "?page=shop.product_details&category_id=$cid&flypage=".$ps_product->get_flypage($db->f("product_id"));
					$url .= "&product_id=" . $db->f("product_id");
				}
		
				$price = '';
				$addtocart_link = '';
		
				if (_SHOW_PRICES == '1' && $show_price) {
					// Show price, but without "including X% tax"
					$price = $ps_product->show_price( $db->f("product_id"), true );
				}
				if (USE_AS_CATALOGUE != 1 && $this->show_addtocart && isset( $GLOBALS['product_info'][$product_id]['price']['product_price_id'] )) {
					$addtocart_link = $sess->url($mm_action_url. "index.php" . "?page=shop.cart&func=cartAdd&product_id=" .  $db->f("product_id"));
				}
		
				// prepare data
				$this->items[$db->f("product_sku")] = array(
					'name' => $db->f("product_name"),
					'link' => $sess->url($mm_action_url. "index.php" . $url),
					'thumb' => ps_product::image_tag($db->f("product_thumb_image")),
					'price' => $price,
					'addtocart_link' => $addtocart_link
				);
			}
		}
	}

}

?>