<?php

/**
 * mod_vmrotmulti_selected
 *
 * @version 1.1
 * @author Creative Pulse
 * @copyright Creative Pulse 2008- Soeren Eberhardt 2004-2005 - Mr PHP 2000-2004
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @link http://www.creativepulse.eu
 */

defined('_JEXEC') or die('Restricted access');

class ModVmrotmultiSelected {

	var $items = array();
	var $width = 0;
	var $height = 0;
	var $interval = 0;
	var $speed = 0;
	var $show_addtocart = true;
	var $visible_items = 4;
	var $autoscroll_interval = 4;

	function instance_id($new = false) {
		static $num = 0;

		if ($new)
			$num++;
		else
			return $num;
	}

	function prepare(&$params) {
		$this->instance_id(true);

		global $mosConfig_absolute_path;
		
		// Load the virtuemart main parse code
		if( file_exists(dirname(__FILE__).'/../../components/com_virtuemart/virtuemart_parser.php' )) {
			require_once( dirname(__FILE__).'/../../components/com_virtuemart/virtuemart_parser.php' );
		} else {
			require_once( dirname(__FILE__).'/../components/com_virtuemart/virtuemart_parser.php' );
		}
		
		$this->width = (int) $params->get('width', 0);
		$this->height = (int) $params->get('height', 0);
		$this->interval = (int) $params->get('interval', 0);
		$this->speed = (int) $params->get('speed', 0);
		$product_id = (string) $params->get('product_id', '');
		$show_price = (bool) $params->get('show_price', 1 ); // Display the Product Price?
		$this->show_addtocart = (bool) $params->get('show_addtocart', 1); // Display the "Add-to-Cart" Link?
		$cur_vendor = $params->get('vendor', 'cur') == 'cur';
		$this->visible_items = (int) $params->get('visible_items', 4);
		$this->autoscroll_interval = ((float) $params->get('autoscroll_interval', 3)) * 1000;
		$cur_vendor = $params->get('vendor', 'cur') == 'cur';

		require_once(CLASSPATH . 'ps_product.php');
		$ps_product = new ps_product;
		$db = new ps_DB;

		preg_match_all('/[0-9]+/', $product_id, $prd_ids);
		
		if (!empty($prd_ids[0])) {
			global $sess, $mm_action_url;
		
			require_once(CLASSPATH.'ps_product_category.php');
			$ps_product_category = new ps_product_category;
		
			// fetch product information
			$q = "SELECT product_id, product_name, product_parent_id, product_thumb_image FROM #__{vm}_product WHERE product_id IN ('" . implode("','", $prd_ids[0]) . "')";
			$db->query($q);
		
			while ($db->next_record()) {
				$product_id = $db->f("product_id");
				$cid = $ps_product_category->get_cid($product_id);
			
				if ($db->f("product_parent_id")) {
					$url = "?page=shop.product_details&category_id=$cid&flypage=".$ps_product->get_flypage($db->f("product_parent_id"));
					$url .= "&product_id=" . $db->f("product_parent_id");
				} else {
					$url = "?page=shop.product_details&category_id=$cid&flypage=".$ps_product->get_flypage($db->f("product_id"));
					$url .= "&product_id=" . $db->f("product_id");
				}
		
				$price = '';
				$addtocart_link = '';
		
				if (_SHOW_PRICES == '1' && $show_price) {
					// Show price, but without "including X% tax"
					$price = $ps_product->show_price( $db->f("product_id"), true );
				}
				if (USE_AS_CATALOGUE != 1 && $this->show_addtocart && isset( $GLOBALS['product_info'][$product_id]['price']['product_price_id'] )) {
					$addtocart_link = $sess->url($mm_action_url. "index.php" . "?page=shop.cart&func=cartAdd&product_id=" .  $db->f("product_id"));
				}
		
				// prepare data
				$this->items[] = array(
					'name' => $db->f("product_name"),
					'link' => $sess->url($mm_action_url. "index.php" . $url),
					'thumb' => ps_product::image_tag($db->f("product_thumb_image")),
					'price' => $price,
					'addtocart_link' => $addtocart_link
				);
			}
		}
	}

}

?>